"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const DatenElement_1 = require("./DatenElement");
const NULL_1 = require("./NULL");
const Parser_1 = require("./Parser");
class DatenElementGruppe {
    constructor() {
        this.data = [];
        this.addDEbin = function (val) {
            this.data.push(new DatenElement_1.DatenElement(val, 3));
        };
    }
    addDE(val) {
        this.data.push(new DatenElement_1.DatenElement(val, 1));
    }
    addDEG(grup) {
        this.data.push(new DatenElement_1.DatenElement(grup, 2));
    }
    parse(parser) {
        let startPos;
        let first = false;
        while (!first || (parser.getCurrentChar() === ':' && parser.hasNext())) {
            if (!first) {
                first = true;
            }
            else {
                parser.nextPos();
            }
            startPos = parser.getCurrentPos();
            parser.setMarkerWithCurrentPos('start');
            if (parser.getCurrentChar() === '@') {
                // binary
                parser.nextPos();
                parser.setMarkerWithCurrentPos('start');
                if (!parser.gotoNextValidChar('@'))
                    throw new Parser_1.ParseError('Seg', 'Error binary!', startPos);
                const len = parseInt(parser.getTextFromMarkerToCurrentPos('start'), 10);
                parser.nextPos();
                parser.setMarkerWithCurrentPos('start');
                parser.setCurrentPos(parser.getCurrentPos() + len);
                if ("+:'".indexOf(parser.getCurrentChar()) === -1)
                    throw new Parser_1.ParseError('Seg', 'Error binary, Wrong Length!' + len, startPos);
                this.addDEbin(parser.getTextFromMarkerToCurrentPos('start'));
                parser.nextPos();
            }
            else if (parser.gotoNextValidCharButIgnoreWith("+:'", '?')) {
                // Normales datenelement
                this.addDE(parser.getTextFromMarkerToCurrentPos('start'));
                // Datengruppe können nicht bestandteil einer datengruppe sein
            }
            else {
                throw new Parser_1.ParseError('Seg', 'Unerwartetes ENDE!', startPos);
            }
        }
    }
    transformForSend() {
        let result = '';
        for (let i = 0; i !== this.data.length; i += 1) {
            if (this.data[i].data !== NULL_1.NULL) {
                if (this.data[i].desc === 1) {
                    const deData = this.data[i].data;
                    result += (i !== 0 ? ':' : '') + deData; // DE
                }
                else if (this.data[i].desc === 2) { // kommt nicht vor
                    const degData = this.data[i].data;
                    result += (i !== 0 ? ':' : '') + degData.transformForSend(); // DEG
                }
                else if (this.data[i].desc === 3) {
                    const deBinData = this.data[i].data;
                    result += (i !== 0 ? ':' : '') + '@' + deBinData.length + '@' + deBinData; // BIN DAT
                }
            }
            else {
                // leer
                result += (i !== 0 ? ':' : '');
            }
        }
        return result;
    }
    getEl(i) {
        return this.data[i - 1].data;
    }
    getElasDEG(i) {
        return this.data[i - 1].data;
    }
    getElasDE(i) {
        return this.data[i - 1].data;
    }
    getElString(i) {
        if (this.data[i - 1] instanceof DatenElement_1.DatenElement) {
            return this.data[i - 1].data;
        }
    }
}
exports.DatenElementGruppe = DatenElementGruppe;
