import { DatenElementGruppe } from './DatenElementGruppe';
export declare namespace Exceptions {
    class OpenFinTSClientException extends Error {
        constructor(message: string);
        toString(): string;
    }
    class GVNotSupportedByKI extends OpenFinTSClientException {
        spVers: any;
        constructor(gvType: any, avail: any);
    }
    class MalformedMessageFormat extends OpenFinTSClientException {
        constructor(message: string);
    }
    class OrderFailedException extends OpenFinTSClientException {
        msgDetail: any;
        constructor(msg: DatenElementGruppe);
    }
    class InternalError extends OpenFinTSClientException {
        constructor(message: string);
    }
    class GVFailedAtKI extends OpenFinTSClientException {
        data: any;
        constructor(msg: any);
    }
    class ConnectionFailedException extends OpenFinTSClientException {
        host: any;
        constructor(hostname: string, port?: string, path?: string);
        toString(): string;
    }
    class MissingBankConnectionDataException extends OpenFinTSClientException {
        blz: any;
        constructor(blz: string);
        toString(): string;
    }
    class OutofSequenceMessageException extends OpenFinTSClientException {
        blz: any;
        constructor(blz?: string);
        toString(): string;
    }
}
