import { Account } from './Account';
import { BPD } from './BPD';
import { Nachricht } from './Nachricht';
import { TotalResult } from './TotalResult';
import { Transaction } from './Transaction';
import { UPD } from './UPD';
export declare class FinTSClient {
    blz: string;
    bankUrl: string;
    kundenId: string;
    pin: string;
    dialogId: number;
    nextMsgNr: number;
    sysId: number;
    protoVersion: number;
    bpd: BPD;
    log: any;
    conLog: any;
    conEstLog: any;
    gvLog: any;
    tan: import("./NULL").NullType;
    upd: UPD;
    konten: Account[];
    private ctry;
    private debugMode;
    private clientName;
    private clientVersion;
    private inConnection;
    private lastSignaturId;
    constructor(blz: string, bankUrl: string, kundenId: string, pin: string);
    clear(): void;
    closeSecure(): void;
    getNewSigId(): number;
    isAnonymous(): boolean;
    sendMsgToDestination: (msg: any, callback: any, inFinishing?: any) => void;
    msgInitDialog(cb: any): void;
    close(): Promise<Nachricht>;
    connect(): Promise<void>;
    convertUmsatzeArrayToListofAllTransactions(umsaetze: any): any[];
    getSepa(forKonto: any): Promise<Account[]>;
    getTransactions(account: Account, fromDate: any, toDate: any): Promise<Transaction[]>;
    getTotal(account: Account): Promise<TotalResult>;
    private logSuccessfullInit;
    private prepareConnection;
    private completeConnection;
    private beautifyBPD;
    private endDialogIfNotCanceled;
    private resetConnection;
    private debugLogMsg;
}
