export declare class ParseError {
    private location;
    private msg;
    private pos;
    constructor(location: string, msg: string, pos: number);
    toString(): string;
}
export declare class Parser {
    protected data: string;
    protected curPos: number;
    protected marker: {
        [index: string]: number;
    };
    constructor(data: string);
    getCurPos(): number;
    getData(): string;
    setMarker(mark: string, pos: number): void;
    setMarkerWithCurrentPos(mark: string): void;
    setPosBackToMarker(mark: string): void;
    getCurrentPos(): number;
    setCurrentPos(pos: number): void;
    getCurrentChar(): string;
    hasNext(): boolean;
    nextPos(): boolean;
    gotoPos(pos: number): boolean;
    getTextFromMarkerToCurrentPos(mark: string): string;
    getTextFromPostoPos(posFrom: number, posTo: number): string;
    findNextValidChar(validChars: string): number;
    gotoNextValidChar(validChars: string): boolean;
    findNextValidString(validStrings: string[]): number;
    gotoNextValidString(validStrings: string[]): boolean;
    gotoNextValidCharButIgnoreWith(validChars: string, demask: string): boolean;
}
